Linux tr1.turkishost.com 5.14.0-570.52.1.el9_6.x86_64 #1 SMP PREEMPT_DYNAMIC Wed Oct 15 06:39:08 EDT 2025 x86_64
LiteSpeed
Server IP : 194.146.50.96 & Your IP : 10.9.249.101
Domains :
Cant Read [ /etc/named.conf ]
User : lakemima
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
bin /
Delete
Unzip
Name
Size
Permission
Date
Action
GET
15.82
KB
-rwxr-xr-x
2022-03-25 11:00
Magick-config
1.43
KB
-rwxr-xr-x
2025-04-01 15:48
MagickCore-config
1.56
KB
-rwxr-xr-x
2025-04-01 15:48
MagickWand-config
1.56
KB
-rwxr-xr-x
2025-04-01 15:48
Wand-config
1.42
KB
-rwxr-xr-x
2025-04-01 15:48
[
51.8
KB
-rwxr-xr-x
2025-03-12 15:52
aclocal
35.52
KB
-rwxr-xr-x
2023-09-27 15:16
aclocal-1.16
35.52
KB
-rwxr-xr-x
2023-09-27 15:16
addr2line
27.75
KB
-rwxr-xr-x
2025-12-18 17:37
animate
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
ar
55.98
KB
-rwxr-xr-x
2025-12-18 17:37
arch
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
arpaname
15.11
KB
-rwxr-xr-x
2025-11-13 11:16
as
710.32
KB
-rwxr-xr-x
2025-12-18 17:37
aspell
151.12
KB
-rwxr-xr-x
2022-01-27 00:47
at
1.02
KB
-rwxr-xr-x
2025-11-12 03:38
atq
1.02
KB
-rwxr-xr-x
2025-11-12 03:38
atrm
1.02
KB
-rwxr-xr-x
2025-11-12 03:38
autoconf
14.42
KB
-rwxr-xr-x
2025-09-21 15:23
autoheader
8.33
KB
-rwxr-xr-x
2025-09-21 15:23
autom4te
31.43
KB
-rwxr-xr-x
2025-09-21 15:23
automake
251.93
KB
-rwxr-xr-x
2023-09-27 15:16
automake-1.16
251.93
KB
-rwxr-xr-x
2023-09-27 15:16
autoreconf
20.57
KB
-rwxr-xr-x
2025-09-21 15:23
autoscan
16.72
KB
-rwxr-xr-x
2025-09-21 15:23
autoupdate
33.08
KB
-rwxr-xr-x
2025-09-21 15:23
awk
698.17
KB
-rwxr-xr-x
2022-03-31 01:25
b2sum
51.79
KB
-rwxr-xr-x
2025-03-12 15:52
base32
35.69
KB
-rwxr-xr-x
2025-03-12 15:52
base64
35.7
KB
-rwxr-xr-x
2025-03-12 15:52
basename
35.67
KB
-rwxr-xr-x
2025-03-12 15:52
basenc
48.02
KB
-rwxr-xr-x
2025-03-12 15:52
bash
1.32
MB
-rwxr-xr-x
2024-04-30 17:33
bashbug-64
6.91
KB
-rwxr-xr-x
2024-04-30 17:33
batch
140
B
-rwxr-xr-x
2025-11-12 03:38
bison
494.76
KB
-rwxr-xr-x
2022-01-27 03:15
bunzip2
39.62
KB
-rwxr-xr-x
2025-02-04 06:42
bzcat
39.62
KB
-rwxr-xr-x
2025-02-04 06:42
bzcmp
2.09
KB
-rwxr-xr-x
2025-02-04 06:42
bzdiff
2.09
KB
-rwxr-xr-x
2025-02-04 06:42
bzgrep
2.01
KB
-rwxr-xr-x
2025-02-04 06:42
bzip2
39.62
KB
-rwxr-xr-x
2025-02-04 06:42
bzip2recover
15.4
KB
-rwxr-xr-x
2025-02-04 06:42
bzless
1.23
KB
-rwxr-xr-x
2025-02-04 06:42
bzmore
1.23
KB
-rwxr-xr-x
2025-02-04 06:42
c++
1.05
MB
-rwxr-xr-x
2025-09-15 18:46
c++filt
27.19
KB
-rwxr-xr-x
2025-12-18 17:37
c89
228
B
-rwxr-xr-x
2025-09-15 18:42
c99
219
B
-rwxr-xr-x
2025-09-15 18:42
cagefs_enter.proxied
1.04
KB
-rwxr-xr-x
2025-05-26 14:09
cal
51.83
KB
-rwxr-xr-x
2026-02-05 00:11
captoinfo
87.79
KB
-rwxr-xr-x
2025-09-21 12:23
cat
35.66
KB
-rwxr-xr-x
2025-03-12 15:52
catchsegv
3.21
KB
-rwxr-xr-x
2026-02-17 14:02
cc
1.04
MB
-rwxr-xr-x
2025-09-15 18:46
chcon
60.24
KB
-rwxr-xr-x
2025-03-12 15:52
chgrp
56.19
KB
-rwxr-xr-x
2025-03-12 15:52
chmod
56.16
KB
-rwxr-xr-x
2025-03-12 15:52
chown
60.19
KB
-rwxr-xr-x
2025-03-12 15:52
chrt
27.31
KB
-rwxr-xr-x
2026-02-05 00:11
cksum
35.57
KB
-rwxr-xr-x
2025-03-12 15:52
cldetect
10.34
KB
-rwxr-xr-x
2025-11-13 12:52
clear
15.15
KB
-rwxr-xr-x
2025-09-21 12:23
cloudlinux-awp-user
1.78
KB
-rwxr-xr-x
2025-12-31 14:19
clwpos-user
1.78
KB
-rwxr-xr-x
2025-12-31 14:19
cmp
40.13
KB
-rwxr-xr-x
2022-01-29 21:15
col
23.23
KB
-rwxr-xr-x
2026-02-05 00:11
colcrt
15.19
KB
-rwxr-xr-x
2026-02-05 00:11
colrm
15.16
KB
-rwxr-xr-x
2026-02-05 00:11
column
35.34
KB
-rwxr-xr-x
2026-02-05 00:11
comm
35.75
KB
-rwxr-xr-x
2025-03-12 15:52
compare
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
composite
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
conjure
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
convert
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
cp
149.24
KB
-rwxr-xr-x
2025-03-12 15:52
cpan
8.37
KB
-rwxr-xr-x
2025-05-14 00:00
cpp
1.05
MB
-rwxr-xr-x
2025-09-15 18:46
crontab
1.49
KB
-rwxr-xr-x
2025-09-25 14:43
crontab.cagefs
40.47
KB
-rwxr-xr-x
2025-11-05 12:30
csplit
108.88
KB
-rwxr-xr-x
2025-03-12 15:52
curl
248.48
KB
-rwxr-xr-x
2026-01-28 11:27
cut
47.8
KB
-rwxr-xr-x
2025-03-12 15:52
cyrusbdb2current
1.58
MB
-rwxr-xr-x
2025-09-25 14:46
date
104.05
KB
-rwxr-xr-x
2025-03-12 15:52
dbiprof
6.06
KB
-rwxr-xr-x
2022-02-16 11:03
dd
68.14
KB
-rwxr-xr-x
2025-03-12 15:52
delv
45.38
KB
-rwxr-xr-x
2025-11-13 11:16
df
84.73
KB
-rwxr-xr-x
2025-03-12 15:52
diff
194.7
KB
-rwxr-xr-x
2022-01-29 21:15
diff3
52.3
KB
-rwxr-xr-x
2022-01-29 21:15
dig
136.59
KB
-rwxr-xr-x
2025-11-13 11:16
dir
137.65
KB
-rwxr-xr-x
2025-03-12 15:52
dircolors
39.8
KB
-rwxr-xr-x
2025-03-12 15:52
dirname
31.48
KB
-rwxr-xr-x
2025-03-12 15:52
display
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
dnstap-read
23.19
KB
-rwxr-xr-x
2025-11-13 11:16
du
149.44
KB
-rwxr-xr-x
2025-03-12 15:52
echo
35.48
KB
-rwxr-xr-x
2025-03-12 15:52
ed
52.51
KB
-rwxr-xr-x
2022-01-30 08:02
egrep
32
B
-rwxr-xr-x
2022-01-31 23:22
enc2xs
40.69
KB
-rwxr-xr-x
2022-02-11 19:42
enchant
23.73
KB
-rwxr-xr-x
2022-01-30 14:02
enchant-lsmod
15.8
KB
-rwxr-xr-x
2022-01-30 14:02
env
44.23
KB
-rwxr-xr-x
2025-03-12 15:52
eps2eps
643
B
-rwxr-xr-x
2025-05-14 19:03
eqn
189.52
KB
-rwxr-xr-x
2022-02-01 13:44
ex
1.38
MB
-rwxr-xr-x
2026-03-24 20:54
expand
39.73
KB
-rwxr-xr-x
2025-03-12 15:52
expr
108.6
KB
-rwxr-xr-x
2025-03-12 15:52
factor
72.05
KB
-rwxr-xr-x
2025-03-12 15:52
false
27.47
KB
-rwxr-xr-x
2025-03-12 15:52
fc-cache
139
B
-rwxr-xr-x
2023-01-23 18:48
fc-cache-64
23.17
KB
-rwxr-xr-x
2023-01-23 22:48
fc-cat
19.16
KB
-rwxr-xr-x
2023-01-23 22:48
fc-conflist
15.13
KB
-rwxr-xr-x
2023-01-23 22:48
fc-list
15.13
KB
-rwxr-xr-x
2023-01-23 22:48
fc-match
15.13
KB
-rwxr-xr-x
2023-01-23 22:48
fc-pattern
15.14
KB
-rwxr-xr-x
2023-01-23 22:48
fc-query
15.13
KB
-rwxr-xr-x
2023-01-23 22:48
fc-scan
15.14
KB
-rwxr-xr-x
2023-01-23 22:48
fc-validate
15.14
KB
-rwxr-xr-x
2023-01-23 22:48
fgrep
32
B
-rwxr-xr-x
2022-01-31 23:22
file
27.74
KB
-rwxr-xr-x
2024-04-03 15:38
find
284.95
KB
-rwxr-xr-x
2024-10-03 00:04
flex
412.64
KB
-rwxr-xr-x
2022-01-30 11:23
flex++
412.64
KB
-rwxr-xr-x
2022-01-30 11:23
flock
23.37
KB
-rwxr-xr-x
2026-02-05 00:11
fmt
39.77
KB
-rwxr-xr-x
2025-03-12 15:52
fold
39.71
KB
-rwxr-xr-x
2025-03-12 15:52
free
23.36
KB
-rwxr-xr-x
2024-04-30 19:43
freetype-config
4.32
KB
-rwxr-xr-x
2025-03-31 18:40
funzip
31.25
KB
-rwxr-xr-x
2025-09-21 14:04
g++
1.05
MB
-rwxr-xr-x
2025-09-15 18:46
gawk
698.17
KB
-rwxr-xr-x
2022-03-31 01:25
gcc
1.04
MB
-rwxr-xr-x
2025-09-15 18:46
gcc-ar
27.67
KB
-rwxr-xr-x
2025-09-15 18:46
gcc-nm
27.64
KB
-rwxr-xr-x
2025-09-15 18:46
gcc-ranlib
27.67
KB
-rwxr-xr-x
2025-09-15 18:46
gcov
473.17
KB
-rwxr-xr-x
2025-09-15 18:46
gcov-dump
291.77
KB
-rwxr-xr-x
2025-09-15 18:46
gcov-tool
320.46
KB
-rwxr-xr-x
2025-09-15 18:46
gem
542
B
-rwxr-xr-x
2025-05-06 07:04
gencat
27.45
KB
-rwxr-xr-x
2026-02-17 14:04
geoiplookup
15.87
KB
-rwxr-xr-x
2022-11-23 19:40
geoiplookup6
15.82
KB
-rwxr-xr-x
2022-11-23 19:40
geqn
189.52
KB
-rwxr-xr-x
2022-02-01 13:44
getconf
35.23
KB
-rwxr-xr-x
2026-02-17 14:04
getent
35.86
KB
-rwxr-xr-x
2026-02-17 14:04
getopt
23.27
KB
-rwxr-xr-x
2026-02-05 00:11
ghostscript
15.13
KB
-rwxr-xr-x
2025-05-14 19:03
git
4.06
MB
-rwxr-xr-x
2025-07-21 19:25
git-receive-pack
4.06
MB
-rwxr-xr-x
2025-07-21 19:25
git-shell
770.68
KB
-rwxr-xr-x
2025-07-21 19:25
git-upload-archive
4.06
MB
-rwxr-xr-x
2025-07-21 19:25
git-upload-pack
4.06
MB
-rwxr-xr-x
2025-07-21 19:25
gm
15.67
KB
-rwxr-xr-x
2022-11-23 20:49
gmake
249.8
KB
-rwxr-xr-x
2024-04-02 15:55
gneqn
916
B
-rwxr-xr-x
2022-02-01 13:44
gnroff
3.21
KB
-rwxr-xr-x
2022-02-01 13:44
gpg
1.07
MB
-rwxr-xr-x
2026-01-16 00:34
gpg-agent
342.27
KB
-rwxr-xr-x
2026-01-16 00:34
gpg-error
36.1
KB
-rwxr-xr-x
2022-02-10 02:24
gpgsplit
27.5
KB
-rwxr-xr-x
2026-01-16 00:34
gpgv
295.43
KB
-rwxr-xr-x
2026-01-16 00:34
gpic
201.72
KB
-rwxr-xr-x
2022-02-01 13:44
gprof
101.48
KB
-rwxr-xr-x
2025-12-18 17:37
grep
154.49
KB
-rwxr-xr-x
2022-01-31 23:22
groff
96.77
KB
-rwxr-xr-x
2022-02-01 13:44
grops
167.26
KB
-rwxr-xr-x
2022-02-01 13:44
grotty
122.2
KB
-rwxr-xr-x
2022-02-01 13:44
groups
35.66
KB
-rwxr-xr-x
2025-03-12 15:52
gs
15.13
KB
-rwxr-xr-x
2025-05-14 19:03
gsnd
281
B
-rwxr-xr-x
2025-05-14 19:03
gtar
518.16
KB
-rwxr-xr-x
2026-01-05 22:41
gtbl
130.86
KB
-rwxr-xr-x
2022-02-01 13:44
gtroff
732.07
KB
-rwxr-xr-x
2022-02-01 13:44
gunzip
2.29
KB
-rwxr-xr-x
2022-10-15 20:26
gzexe
6.3
KB
-rwxr-xr-x
2022-10-15 20:26
gzip
89.63
KB
-rwxr-xr-x
2022-10-15 20:26
h2ph
28.69
KB
-rwxr-xr-x
2025-07-28 06:54
h2xs
59.5
KB
-rwxr-xr-x
2025-07-28 06:53
head
43.8
KB
-rwxr-xr-x
2025-03-12 15:52
hexdump
51.41
KB
-rwxr-xr-x
2026-02-05 00:11
host
108.57
KB
-rwxr-xr-x
2025-11-13 11:16
hostid
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
hostname
23.84
KB
-rwxr-xr-x
2022-02-14 14:22
hunspell
102.67
KB
-rwxr-xr-x
2022-01-31 23:22
iconv
64.09
KB
-rwxr-xr-x
2026-02-17 14:04
icu-config
205
B
-rwxr-xr-x
2025-07-29 19:13
icu-config-64
21.67
KB
-rwxr-xr-x
2025-07-29 19:16
icuinfo
15.49
KB
-rwxr-xr-x
2025-07-29 19:17
id
39.71
KB
-rwxr-xr-x
2025-03-12 15:52
identify
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
idn
36.46
KB
-rwxr-xr-x
2022-02-14 18:33
ifnames
4.03
KB
-rwxr-xr-x
2025-09-21 15:23
import
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
infocmp
63.68
KB
-rwxr-xr-x
2025-09-21 12:23
infotocap
87.79
KB
-rwxr-xr-x
2025-09-21 12:23
install
149.29
KB
-rwxr-xr-x
2025-03-12 15:52
instmodsh
4.1
KB
-rwxr-xr-x
2022-02-24 12:56
ionice
15.21
KB
-rwxr-xr-x
2026-02-05 00:11
ipcrm
19.23
KB
-rwxr-xr-x
2026-02-05 00:11
ipcs
39.34
KB
-rwxr-xr-x
2026-02-05 00:11
isosize
15.16
KB
-rwxr-xr-x
2026-02-05 00:11
ispell
992
B
-rwxr-xr-x
2019-10-08 03:15
join
51.9
KB
-rwxr-xr-x
2025-03-12 15:52
kill
31.29
KB
-rwxr-xr-x
2026-02-05 00:11
ld
1.71
MB
-rwxr-xr-x
2025-12-18 17:37
ld.bfd
1.71
MB
-rwxr-xr-x
2025-12-18 17:37
ldd
5.32
KB
-rwxr-xr-x
2026-02-17 14:02
less
197.7
KB
-rwxr-xr-x
2025-09-21 15:35
lessecho
15.17
KB
-rwxr-xr-x
2025-09-21 15:35
lesskey
24.61
KB
-rwxr-xr-x
2025-09-21 15:35
lesspipe.sh
3.5
KB
-rwxr-xr-x
2025-09-21 14:44
lex
412.64
KB
-rwxr-xr-x
2022-01-30 11:23
libnetcfg
15.41
KB
-rwxr-xr-x
2025-07-28 06:54
libtool
359.18
KB
-rwxr-xr-x
2024-10-01 20:49
libtoolize
126.17
KB
-rwxr-xr-x
2024-10-01 20:49
link
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
ln
60.16
KB
-rwxr-xr-x
2025-03-12 15:52
locale
59.08
KB
-rwxr-xr-x
2026-02-17 14:04
localedef
314.06
KB
-rwxr-xr-x
2026-02-17 14:04
logger
35.98
KB
-rwxr-xr-x
2026-02-05 00:11
login
43.45
KB
-rwxr-xr-x
2026-02-05 00:11
logname
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
look
19.17
KB
-rwxr-xr-x
2026-02-05 00:11
ls
137.64
KB
-rwxr-xr-x
2025-03-12 15:52
lto-dump
26.59
MB
-rwxr-xr-x
2025-09-15 18:46
m4
240.4
KB
-rwxr-xr-x
2022-03-31 10:28
make
249.8
KB
-rwxr-xr-x
2024-04-02 15:55
make-dummy-cert
614
B
-rwxr-xr-x
2026-01-28 19:17
mariadb
5.07
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-access
109.34
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-admin
4.85
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-binlog
5.13
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-check
4.84
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-conv
4.56
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-dump
4.94
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-embedded
24.09
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-find-rows
3.21
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-import
4.84
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-plugin
4.53
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-secure-installation
13.48
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-setpermission
17.56
KB
-rwxr-xr-x
2026-01-31 20:35
mariadb-show
4.83
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-slap
4.86
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-tzinfo-to-sql
4.53
MB
-rwxr-xr-x
2026-01-31 21:12
mariadb-waitpid
4.52
MB
-rwxr-xr-x
2026-01-31 21:12
mcookie
27.31
KB
-rwxr-xr-x
2026-02-05 00:11
md5sum
39.64
KB
-rwxr-xr-x
2025-03-12 15:52
mesg
15.14
KB
-rwxr-xr-x
2026-02-05 00:11
mkdir
68.31
KB
-rwxr-xr-x
2025-03-12 15:52
mkfifo
39.83
KB
-rwxr-xr-x
2025-03-12 15:52
mknod
43.88
KB
-rwxr-xr-x
2025-03-12 15:52
mktemp
39.8
KB
-rwxr-xr-x
2025-03-12 15:52
mogrify
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
montage
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
more
43.43
KB
-rwxr-xr-x
2026-02-05 00:11
msql2mysql
1.42
KB
-rwxr-xr-x
2026-01-31 20:35
mv
141.17
KB
-rwxr-xr-x
2025-03-12 15:52
my_print_defaults
4.53
MB
-rwxr-xr-x
2026-01-31 21:12
mysql
5.07
MB
-rwxr-xr-x
2026-01-31 21:12
mysql_config
4.5
KB
-rwxr-xr-x
2026-01-31 20:35
mysql_find_rows
3.21
KB
-rwxr-xr-x
2026-01-31 20:35
mysql_waitpid
4.52
MB
-rwxr-xr-x
2026-01-31 21:12
mysqlaccess
109.34
KB
-rwxr-xr-x
2026-01-31 20:35
mysqladmin
4.85
MB
-rwxr-xr-x
2026-01-31 21:12
mysqlbinlog
5.13
MB
-rwxr-xr-x
2026-01-31 21:12
mysqlcheck
4.84
MB
-rwxr-xr-x
2026-01-31 21:12
mysqldump
4.94
MB
-rwxr-xr-x
2026-01-31 21:12
mysqlimport
4.84
MB
-rwxr-xr-x
2026-01-31 21:12
mysqlshow
4.83
MB
-rwxr-xr-x
2026-01-31 21:12
mytop
72.03
KB
-rwxr-xr-x
2026-01-31 20:35
namei
23.23
KB
-rwxr-xr-x
2026-02-05 00:11
nano
346.2
KB
-rwxr-xr-x
2025-03-13 06:12
neqn
916
B
-rwxr-xr-x
2022-02-01 13:44
nice
35.67
KB
-rwxr-xr-x
2025-03-12 15:52
nl
100.71
KB
-rwxr-xr-x
2025-03-12 15:52
nm
44.73
KB
-rwxr-xr-x
2025-12-18 17:37
nohup
35.58
KB
-rwxr-xr-x
2025-03-12 15:52
nproc
35.69
KB
-rwxr-xr-x
2025-03-12 15:52
nroff
3.21
KB
-rwxr-xr-x
2022-02-01 13:44
nslookup
112.52
KB
-rwxr-xr-x
2025-11-13 11:16
nsupdate
71.8
KB
-rwxr-xr-x
2025-11-13 11:16
numfmt
55.83
KB
-rwxr-xr-x
2025-03-12 15:52
objcopy
185.37
KB
-rwxr-xr-x
2025-12-18 17:37
objdump
413.11
KB
-rwxr-xr-x
2025-12-18 17:37
od
64.06
KB
-rwxr-xr-x
2025-03-12 15:52
openssl
1.07
MB
-rwxr-xr-x
2026-01-28 19:17
pango-list
19.11
KB
-rwxr-xr-x
2023-04-07 13:19
pango-segmentation
19.13
KB
-rwxr-xr-x
2023-04-07 13:19
pango-view
60.17
KB
-rwxr-xr-x
2023-04-07 13:19
passenger
1.73
KB
-rwxr-xr-x
2026-01-13 21:09
passwd
1.02
KB
-rwxr-xr-x
2022-04-14 17:45
paste
35.58
KB
-rwxr-xr-x
2025-03-12 15:52
patch
195.02
KB
-rwxr-xr-x
2022-03-25 18:42
pathchk
35.66
KB
-rwxr-xr-x
2025-03-12 15:52
pdf2dsc
701
B
-rwxr-xr-x
2025-05-14 19:03
pdf2ps
913
B
-rwxr-xr-x
2025-05-14 19:03
perl
15.13
KB
-rwxr-xr-x
2025-07-28 06:54
perl5.32.1
15.13
KB
-rwxr-xr-x
2025-07-28 06:54
perlbug
43.81
KB
-rwxr-xr-x
2025-07-28 06:54
perldoc
118
B
-rwxr-xr-x
2022-02-15 02:51
perlivp
10.56
KB
-rwxr-xr-x
2025-07-28 06:53
perlml
14.18
KB
-rwxr-xr-x
2022-08-10 23:54
perlthanks
43.81
KB
-rwxr-xr-x
2025-07-28 06:54
pgrep
31.42
KB
-rwxr-xr-x
2024-04-30 19:43
php
937
B
-rwxr-xr-x
2025-07-01 19:06
pic
201.72
KB
-rwxr-xr-x
2022-02-01 13:44
piconv
8.08
KB
-rwxr-xr-x
2022-02-11 19:42
ping
89.33
KB
-rwxr-xr-x
2025-10-20 15:44
pinky
35.61
KB
-rwxr-xr-x
2025-03-12 15:52
pkg-config
335
B
-rwxr-xr-x
2023-04-06 23:27
pkill
31.42
KB
-rwxr-xr-x
2024-04-30 19:43
pl2pm
4.43
KB
-rwxr-xr-x
2025-07-28 06:54
pmap
35.39
KB
-rwxr-xr-x
2024-04-30 19:43
pod2html
4.04
KB
-rwxr-xr-x
2025-07-28 06:54
pod2man
14.68
KB
-rwxr-xr-x
2022-03-25 15:10
pod2text
10.55
KB
-rwxr-xr-x
2022-03-25 15:10
pod2usage
4.01
KB
-rwxr-xr-x
2022-02-11 19:01
podchecker
3.57
KB
-rwxr-xr-x
2022-02-11 22:01
post-grohtml
199.76
KB
-rwxr-xr-x
2022-02-01 13:44
pr
72.28
KB
-rwxr-xr-x
2025-03-12 15:52
pre-grohtml
92.92
KB
-rwxr-xr-x
2022-02-01 13:44
precat
5.53
KB
-rwxr-xr-x
2019-10-08 03:15
preunzip
5.53
KB
-rwxr-xr-x
2019-10-08 03:15
prezip
5.53
KB
-rwxr-xr-x
2019-10-08 03:15
prezip-bin
15.69
KB
-rwxr-xr-x
2022-01-27 00:47
printenv
31.47
KB
-rwxr-xr-x
2025-03-12 15:52
printf
51.77
KB
-rwxr-xr-x
2025-03-12 15:52
prove
13.24
KB
-rwxr-xr-x
2022-02-16 14:58
ps
141.15
KB
-rwxr-xr-x
2024-04-30 19:43
ps2ascii
635
B
-rwxr-xr-x
2025-05-14 19:03
ps2epsi
1.24
KB
-rwxr-xr-x
2025-05-14 19:03
ps2pdf
276
B
-rwxr-xr-x
2025-05-14 19:03
ps2pdf12
219
B
-rwxr-xr-x
2025-05-14 19:03
ps2pdf13
219
B
-rwxr-xr-x
2025-05-14 19:03
ps2pdf14
219
B
-rwxr-xr-x
2025-05-14 19:03
ps2pdfwr
1.06
KB
-rwxr-xr-x
2025-05-14 19:03
ps2ps
651
B
-rwxr-xr-x
2025-05-14 19:03
ps2ps2
673
B
-rwxr-xr-x
2025-05-14 19:03
ptx
129.03
KB
-rwxr-xr-x
2025-03-12 15:52
pwd
35.7
KB
-rwxr-xr-x
2025-03-12 15:52
pwdx
15.28
KB
-rwxr-xr-x
2024-04-30 19:43
pydoc
78
B
-rwxr-xr-x
2026-03-10 20:32
pydoc3
78
B
-rwxr-xr-x
2026-03-10 20:32
pydoc3.9
78
B
-rwxr-xr-x
2026-03-10 20:32
ranlib
56
KB
-rwxr-xr-x
2025-12-18 17:37
readelf
667.29
KB
-rwxr-xr-x
2025-12-18 17:37
readlink
39.69
KB
-rwxr-xr-x
2025-03-12 15:52
realpath
39.77
KB
-rwxr-xr-x
2025-03-12 15:52
recode
31.93
KB
-rwxr-xr-x
2022-11-02 14:35
red
92
B
-rwxr-xr-x
2022-01-30 08:02
rename
23.23
KB
-rwxr-xr-x
2026-02-05 00:11
renew-dummy-cert
729
B
-rwxr-xr-x
2026-01-28 19:17
renice
15.16
KB
-rwxr-xr-x
2026-02-05 00:11
replace
4.5
MB
-rwxr-xr-x
2026-01-31 21:12
reset
27.34
KB
-rwxr-xr-x
2025-09-21 12:23
rev
15.16
KB
-rwxr-xr-x
2026-02-05 00:11
rm
60.21
KB
-rwxr-xr-x
2025-03-12 15:52
rmdir
43.61
KB
-rwxr-xr-x
2025-03-12 15:52
rnano
346.2
KB
-rwxr-xr-x
2025-03-13 06:12
ruby
15.27
KB
-rwxr-xr-x
2025-05-06 06:53
run-with-aspell
89
B
-rwxr-xr-x
2022-01-27 00:47
runcon
35.65
KB
-rwxr-xr-x
2025-03-12 15:52
rvi
1.38
MB
-rwxr-xr-x
2026-03-24 20:54
rview
1.38
MB
-rwxr-xr-x
2026-03-24 20:54
scalar
819.34
KB
-rwxr-xr-x
2025-07-21 19:25
scl
39.55
KB
-rwxr-xr-x
2023-04-07 04:57
scl_enabled
262
B
-rwxr-xr-x
2021-07-27 18:14
scl_source
1.88
KB
-rwxr-xr-x
2021-07-27 18:14
scp
132.93
KB
-rwxr-xr-x
2025-12-18 04:52
screen
484.21
KB
-rwxr-xr-x
2022-01-04 10:53
script
51.58
KB
-rwxr-xr-x
2026-02-05 00:11
sdiff
44.2
KB
-rwxr-xr-x
2022-01-29 21:15
sed
114.01
KB
-rwxr-xr-x
2022-02-15 13:36
selectorctl
7.63
KB
-rwxr-xr-x
2025-12-15 17:09
seq
47.79
KB
-rwxr-xr-x
2025-03-12 15:52
setsid
15.15
KB
-rwxr-xr-x
2026-02-05 00:11
setterm
35.33
KB
-rwxr-xr-x
2026-02-05 00:11
sftp
140.93
KB
-rwxr-xr-x
2025-12-18 04:52
sh
1.32
MB
-rwxr-xr-x
2024-04-30 17:33
sha1sum
39.64
KB
-rwxr-xr-x
2025-03-12 15:52
sha224sum
39.64
KB
-rwxr-xr-x
2025-03-12 15:52
sha256sum
39.64
KB
-rwxr-xr-x
2025-03-12 15:52
sha384sum
39.64
KB
-rwxr-xr-x
2025-03-12 15:52
sha512sum
39.64
KB
-rwxr-xr-x
2025-03-12 15:52
shred
51.88
KB
-rwxr-xr-x
2025-03-12 15:52
shuf
48.01
KB
-rwxr-xr-x
2025-03-12 15:52
size
31.61
KB
-rwxr-xr-x
2025-12-18 17:37
skill
31.4
KB
-rwxr-xr-x
2024-04-30 19:43
slabtop
23.42
KB
-rwxr-xr-x
2024-04-30 19:43
sleep
35.65
KB
-rwxr-xr-x
2025-03-12 15:52
snice
31.4
KB
-rwxr-xr-x
2024-04-30 19:43
sort
113.09
KB
-rwxr-xr-x
2025-03-12 15:52
spell
125
B
-rwxr-xr-x
2019-10-08 03:15
splain
18.96
KB
-rwxr-xr-x
2025-07-28 06:54
split
52.31
KB
-rwxr-xr-x
2025-03-12 15:52
sprof
35.45
KB
-rwxr-xr-x
2026-02-17 14:04
sqlite3
1.54
MB
-rwxr-xr-x
2025-11-12 01:18
ssh
843.39
KB
-rwxr-xr-x
2025-12-18 04:52
ssh-add
164.73
KB
-rwxr-xr-x
2025-12-18 04:52
ssh-agent
280.88
KB
-rwxr-xr-x
2025-12-18 04:52
ssh-copy-id
12.38
KB
-rwxr-xr-x
2025-12-18 04:52
ssh-keygen
454.85
KB
-rwxr-xr-x
2025-12-18 04:52
ssh-keyscan
197.29
KB
-rwxr-xr-x
2025-12-18 04:52
stat
80.06
KB
-rwxr-xr-x
2025-03-12 15:52
stdbuf
43.74
KB
-rwxr-xr-x
2025-03-12 15:52
strace
2.08
MB
-rwxr-xr-x
2025-03-12 22:11
stream
15.27
KB
-rwxr-xr-x
2025-04-01 15:55
strings
31.74
KB
-rwxr-xr-x
2025-12-18 17:37
strip
185.37
KB
-rwxr-xr-x
2025-12-18 17:37
stty
75.83
KB
-rwxr-xr-x
2025-03-12 15:52
sum
35.59
KB
-rwxr-xr-x
2025-03-12 15:52
sync
35.54
KB
-rwxr-xr-x
2025-03-12 15:52
tabs
19.16
KB
-rwxr-xr-x
2025-09-21 12:23
tac
104.6
KB
-rwxr-xr-x
2025-03-12 15:52
tail
68.09
KB
-rwxr-xr-x
2025-03-12 15:52
tar
518.16
KB
-rwxr-xr-x
2026-01-05 22:41
taskset
23.23
KB
-rwxr-xr-x
2026-02-05 00:11
tbl
130.86
KB
-rwxr-xr-x
2022-02-01 13:44
tclsh
15.69
KB
-rwxr-xr-x
2022-10-16 00:29
tclsh8.6
15.69
KB
-rwxr-xr-x
2022-10-16 00:29
tee
35.69
KB
-rwxr-xr-x
2025-03-12 15:52
test
43.79
KB
-rwxr-xr-x
2025-03-12 15:52
tic
87.79
KB
-rwxr-xr-x
2025-09-21 12:23
timeout
40.17
KB
-rwxr-xr-x
2025-03-12 15:52
tload
19.34
KB
-rwxr-xr-x
2024-04-30 19:43
tmpwatch
36.03
KB
-rwxr-xr-x
2022-02-11 14:52
toe
23.23
KB
-rwxr-xr-x
2025-09-21 12:23
top
132.27
KB
-rwxr-xr-x
2024-04-30 19:43
touch
92.03
KB
-rwxr-xr-x
2025-03-12 15:52
tput
27.25
KB
-rwxr-xr-x
2025-09-21 12:23
tr
47.87
KB
-rwxr-xr-x
2025-03-12 15:52
troff
732.07
KB
-rwxr-xr-x
2022-02-01 13:44
true
27.47
KB
-rwxr-xr-x
2025-03-12 15:52
truncate
35.66
KB
-rwxr-xr-x
2025-03-12 15:52
tset
27.34
KB
-rwxr-xr-x
2025-09-21 12:23
tsort
47.79
KB
-rwxr-xr-x
2025-03-12 15:52
tty
31.65
KB
-rwxr-xr-x
2025-03-12 15:52
tzselect
14.99
KB
-rwxr-xr-x
2026-02-17 14:01
uapi
1.02
KB
-rwxr-xr-x
2025-10-22 15:21
ul
23.26
KB
-rwxr-xr-x
2026-02-05 00:11
uname
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
unexpand
39.73
KB
-rwxr-xr-x
2025-03-12 15:52
uniq
43.83
KB
-rwxr-xr-x
2025-03-12 15:52
unlink
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
unzip
195.95
KB
-rwxr-xr-x
2025-09-21 14:04
unzipsfx
87.7
KB
-rwxr-xr-x
2025-09-21 14:04
uptime
15.29
KB
-rwxr-xr-x
2024-04-30 19:43
users
35.68
KB
-rwxr-xr-x
2025-03-12 15:52
utmpdump
23.21
KB
-rwxr-xr-x
2026-02-05 00:11
vdir
137.65
KB
-rwxr-xr-x
2025-03-12 15:52
vi
691
B
-rwxr-xr-x
2026-03-24 20:54
view
150
B
-rwxr-xr-x
2026-03-24 20:54
vmstat
39.41
KB
-rwxr-xr-x
2024-04-30 19:43
watch
27.87
KB
-rwxr-xr-x
2024-04-30 19:43
wc
43.73
KB
-rwxr-xr-x
2025-03-12 15:52
wget
521.41
KB
-rwxr-xr-x
2024-09-03 14:58
whereis
31.84
KB
-rwxr-xr-x
2026-02-05 00:11
which
27.89
KB
-rwxr-xr-x
2025-08-05 09:19
who
51.77
KB
-rwxr-xr-x
2025-03-12 15:52
whoami
31.66
KB
-rwxr-xr-x
2025-03-12 15:52
word-list-compress
15.7
KB
-rwxr-xr-x
2022-01-27 00:47
x86_64-redhat-linux-c++
1.05
MB
-rwxr-xr-x
2025-09-15 18:46
x86_64-redhat-linux-g++
1.05
MB
-rwxr-xr-x
2025-09-15 18:46
x86_64-redhat-linux-gcc
1.04
MB
-rwxr-xr-x
2025-09-15 18:46
x86_64-redhat-linux-gcc-11
1.04
MB
-rwxr-xr-x
2025-09-15 18:46
xargs
64.09
KB
-rwxr-xr-x
2024-10-03 00:04
xmlcatalog
23.15
KB
-rwxr-xr-x
2025-12-01 06:41
xmllint
80.56
KB
-rwxr-xr-x
2025-12-01 06:41
xmlwf
39.63
KB
-rwxr-xr-x
2025-11-26 19:14
xsltproc
31.23
KB
-rwxr-xr-x
2026-03-31 18:37
xsubpp
4.96
KB
-rwxr-xr-x
2022-02-16 11:56
yes
31.51
KB
-rwxr-xr-x
2025-03-12 15:52
zcat
1.94
KB
-rwxr-xr-x
2022-10-15 20:26
zcmp
1.64
KB
-rwxr-xr-x
2022-10-15 20:26
zdiff
6.31
KB
-rwxr-xr-x
2022-10-15 20:26
zegrep
33
B
-rwxr-xr-x
2022-10-15 20:26
zfgrep
33
B
-rwxr-xr-x
2022-10-15 20:26
zforce
2.04
KB
-rwxr-xr-x
2022-10-15 20:26
zgrep
7.93
KB
-rwxr-xr-x
2022-10-15 20:26
zip
221.09
KB
-rwxr-xr-x
2023-04-07 17:02
zipcloak
75.7
KB
-rwxr-xr-x
2023-04-07 17:02
zipgrep
2.89
KB
-rwxr-xr-x
2008-10-10 20:40
zipinfo
195.95
KB
-rwxr-xr-x
2025-09-21 14:04
zipnote
67.61
KB
-rwxr-xr-x
2023-04-07 17:02
zipsplit
63.58
KB
-rwxr-xr-x
2023-04-07 17:02
zless
2.16
KB
-rwxr-xr-x
2022-10-15 20:26
zmore
1.8
KB
-rwxr-xr-x
2022-10-15 20:26
znew
4.47
KB
-rwxr-xr-x
2022-10-15 20:26
Save
Rename
#!/usr/bin/sh # Copyright (c) 1999-2020 Philip Hands <phil@hands.com> # 2020 Matthias Blümel <blaimi@blaimi.de> # 2017 Sebastien Boyron <seb@boyron.eu> # 2013 Martin Kletzander <mkletzan@redhat.com> # 2010 Adeodato =?iso-8859-1?Q?Sim=F3?= <asp16@alu.ua.es> # 2010 Eric Moret <eric.moret@gmail.com> # 2009 Xr <xr@i-jeuxvideo.com> # 2007 Justin Pryzby <justinpryzby@users.sourceforge.net> # 2004 Reini Urban <rurban@x-ray.at> # 2003 Colin Watson <cjwatson@debian.org> # All rights reserved. # # Redistribution and use in source and binary forms, with or without # modification, are permitted provided that the following conditions # are met: # 1. Redistributions of source code must retain the above copyright # notice, this list of conditions and the following disclaimer. # 2. Redistributions in binary form must reproduce the above copyright # notice, this list of conditions and the following disclaimer in the # documentation and/or other materials provided with the distribution. # # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. # Shell script to install your public key(s) on a remote machine # See the ssh-copy-id(1) man page for details # shellcheck shell=dash # check that we have something mildly sane as our shell, or try to find something better if false ^ printf "%s: WARNING: ancient shell, hunting for a more modern one... " "$0" then SANE_SH=${SANE_SH:-/usr/bin/ksh} if printf 'true ^ false\n' | "$SANE_SH" then printf "'%s' seems viable.\\n" "$SANE_SH" exec "$SANE_SH" "$0" "$@" else cat <<-EOF oh dear. If you have a more recent shell available, that supports \$(...) etc. please try setting the environment variable SANE_SH to the path of that shell, and then retry running this script. If that works, please report a bug describing your setup, and the shell you used to make it work. EOF printf '%s: ERROR: Less dimwitted shell required.\n' "$0" exit 1 fi fi # shellcheck disable=SC2010 DEFAULT_PUB_ID_FILE=$(ls -t "${HOME}"/.ssh/id*.pub 2>/dev/null | grep -v -- '-cert.pub$' | head -n 1) SSH="ssh -a -x" umask 0177 usage () { printf 'Usage: %s [-h|-?|-f|-n|-s] [-i [identity_file]] [-p port] [-F alternative ssh_config file] [[-o <ssh -o options>] ...] [user@]hostname\n' "$0" >&2 printf '\t-f: force mode -- copy keys without trying to check if they are already installed\n' >&2 printf '\t-n: dry run -- no keys are actually copied\n' >&2 printf '\t-s: use sftp -- use sftp instead of executing remote-commands. Can be useful if the remote only allows sftp\n' >&2 printf '\t-h|-?: print this help\n' >&2 exit 1 } # escape any single quotes in an argument quote() { printf '%s\n' "$1" | sed -e "s/'/'\\\\''/g" } use_id_file() { L_ID_FILE="$1" if [ -z "$L_ID_FILE" ] ; then printf '%s: ERROR: no ID file found\n' "$0" exit 1 fi if expr "$L_ID_FILE" : '.*\.pub$' >/dev/null ; then PUB_ID_FILE="$L_ID_FILE" else PUB_ID_FILE="$L_ID_FILE.pub" fi [ "$FORCED" ] || PRIV_ID_FILE=$(dirname "$PUB_ID_FILE")/$(basename "$PUB_ID_FILE" .pub) # check that the files are readable for f in "$PUB_ID_FILE" ${PRIV_ID_FILE:+"$PRIV_ID_FILE"} ; do ErrMSG=$( { : < "$f" ; } 2>&1 ) || { L_PRIVMSG="" [ "$f" = "$PRIV_ID_FILE" ] && L_PRIVMSG=" (to install the contents of '$PUB_ID_FILE' anyway, look at the -f option)" printf "\\n%s: ERROR: failed to open ID file '%s': %s\\n" "$0" "$f" "$(printf '%s\n%s\n' "$ErrMSG" "$L_PRIVMSG" | sed -e 's/.*: *//')" exit 1 } done printf '%s: INFO: Source of key(s) to be installed: "%s"\n' "$0" "$PUB_ID_FILE" >&2 GET_ID="cat \"$PUB_ID_FILE\"" } if [ -n "$SSH_AUTH_SOCK" ] && ssh-add -L >/dev/null 2>&1 ; then GET_ID="ssh-add -L" fi while getopts "i:o:p:F:fnsh?" OPT do case "$OPT" in i) [ "${SEEN_OPT_I}" ] && { printf '\n%s: ERROR: -i option must not be specified more than once\n\n' "$0" usage } SEEN_OPT_I="yes" use_id_file "${OPTARG:-$DEFAULT_PUB_ID_FILE}" ;; o|p|F) SSH_OPTS="${SSH_OPTS:+$SSH_OPTS }-$OPT '$(quote "${OPTARG}")'" ;; f) FORCED=1 ;; n) DRY_RUN=1 ;; s) SFTP=sftp ;; h|\?) usage ;; esac done #shift all args to keep only USER_HOST shift $((OPTIND-1)) if [ $# = 0 ] ; then usage fi if [ $# != 1 ] ; then printf '%s: ERROR: Too many arguments. Expecting a target hostname, got: %s\n\n' "$0" "$SAVEARGS" >&2 usage fi # drop trailing colon USER_HOST="$*" # tack the hostname onto SSH_OPTS SSH_OPTS="${SSH_OPTS:+$SSH_OPTS }'$(quote "$USER_HOST")'" # and populate "$@" for later use (only way to get proper quoting of options) eval set -- "$SSH_OPTS" # shellcheck disable=SC2086 if [ -z "$(eval $GET_ID)" ] && [ -r "${PUB_ID_FILE:=$DEFAULT_PUB_ID_FILE}" ] ; then use_id_file "$PUB_ID_FILE" fi # shellcheck disable=SC2086 if [ -z "$(eval $GET_ID)" ] ; then printf '%s: ERROR: No identities found\n' "$0" >&2 exit 1 fi # filter_ids() # tries to log in using the keys piped to it, and filters out any that work filter_ids() { L_SUCCESS="$1" L_TMP_ID_FILE="$SCRATCH_DIR"/popids_tmp_id L_OUTPUT_FILE="$SCRATCH_DIR"/popids_output # repopulate "$@" inside this function eval set -- "$SSH_OPTS" while read -r ID || [ "$ID" ] ; do printf '%s\n' "$ID" > "$L_TMP_ID_FILE" # the next line assumes $PRIV_ID_FILE only set if using a single id file - this # assumption will break if we implement the possibility of multiple -i options. # The point being that if file based, ssh needs the private key, which it cannot # find if only given the contents of the .pub file in an unrelated tmpfile $SSH -i "${PRIV_ID_FILE:-$L_TMP_ID_FILE}" \ -o ControlPath=none \ -o LogLevel=INFO \ -o PreferredAuthentications=publickey \ -o IdentitiesOnly=yes "$@" exit >"$L_OUTPUT_FILE" 2>&1 </dev/null if [ "$?" = "$L_SUCCESS" ] || { [ "$SFTP" ] && grep 'allows sftp connections only' "$L_OUTPUT_FILE" >/dev/null # this error counts as a success if we're setting up an sftp connection } then : > "$L_TMP_ID_FILE" else grep 'Permission denied' "$L_OUTPUT_FILE" >/dev/null || { sed -e 's/^/ERROR: /' <"$L_OUTPUT_FILE" >"$L_TMP_ID_FILE" cat >/dev/null #consume the other keys, causing loop to end } fi cat "$L_TMP_ID_FILE" done } # populate_new_ids() uses several global variables ($USER_HOST, $SSH_OPTS ...) # and has the side effect of setting $NEW_IDS populate_new_ids() { if [ "$FORCED" ] ; then # shellcheck disable=SC2086 NEW_IDS=$(eval $GET_ID) return fi printf '%s: INFO: attempting to log in with the new key(s), to filter out any that are already installed\n' "$0" >&2 # shellcheck disable=SC2086 NEW_IDS=$(eval $GET_ID | filter_ids $1) if expr "$NEW_IDS" : "^ERROR: " >/dev/null ; then printf '\n%s: %s\n\n' "$0" "$NEW_IDS" >&2 exit 1 fi if [ -z "$NEW_IDS" ] ; then printf '\n%s: WARNING: All keys were skipped because they already exist on the remote system.\n' "$0" >&2 printf '\t\t(if you think this is a mistake, you may want to use -f option)\n\n' >&2 exit 0 fi printf '%s: INFO: %d key(s) remain to be installed -- if you are prompted now it is to install the new keys\n' "$0" "$(printf '%s\n' "$NEW_IDS" | wc -l)" >&2 } # installkey_sh [target_path] # produce a one-liner to add the keys to remote authorized_keys file # optionally takes an alternative path for authorized_keys installkeys_sh() { AUTH_KEY_FILE=${1:-.ssh/authorized_keys} AUTH_KEY_DIR=$(dirname "${AUTH_KEY_FILE}") # In setting INSTALLKEYS_SH: # the tr puts it all on one line (to placate tcsh) # (hence the excessive use of semi-colons (;) ) # then in the command: # cd to be at $HOME, just in case; # the -z `tail ...` checks for a trailing newline. The echo adds one if was missing # the cat adds the keys we're getting via STDIN # and if available restorecon is used to restore the SELinux context INSTALLKEYS_SH=$(tr '\t\n' ' ' <<-EOF cd; umask 077; mkdir -p "${AUTH_KEY_DIR}" && { [ -z \`tail -1c ${AUTH_KEY_FILE} 2>/dev/null\` ] || echo >> "${AUTH_KEY_FILE}" || exit 1; } && cat >> "${AUTH_KEY_FILE}" || exit 1; if type restorecon >/dev/null 2>&1; then restorecon -F "${AUTH_KEY_DIR}" "${AUTH_KEY_FILE}"; fi EOF ) # to defend against quirky remote shells: use 'exec sh -c' to get POSIX; printf "exec sh -c '%s'" "${INSTALLKEYS_SH}" } #shellcheck disable=SC2120 # the 'eval set' confuses this installkeys_via_sftp() { # repopulate "$@" inside this function eval set -- "$SSH_OPTS" L_KEYS=$SCRATCH_DIR/authorized_keys L_SHARED_CON=$SCRATCH_DIR/master-conn $SSH -f -N -M -S "$L_SHARED_CON" "$@" L_CLEANUP="$SSH -S $L_SHARED_CON -O exit 'ignored' >/dev/null 2>&1 ; $SCRATCH_CLEANUP" #shellcheck disable=SC2064 trap "$L_CLEANUP" EXIT TERM INT QUIT sftp -b - -o "ControlPath=$L_SHARED_CON" "ignored" <<-EOF || return 1 -get .ssh/authorized_keys $L_KEYS EOF # add a newline or create file if it's missing, same like above [ -z "$(tail -1c "$L_KEYS" 2>/dev/null)" ] || echo >> "$L_KEYS" # append the keys being piped in here cat >> "$L_KEYS" sftp -b - -o "ControlPath=$L_SHARED_CON" "ignored" <<-EOF || return 1 -mkdir .ssh chmod 700 .ssh put $L_KEYS .ssh/authorized_keys chmod 600 .ssh/authorized_keys EOF #shellcheck disable=SC2064 eval "$L_CLEANUP" && trap "$SCRATCH_CLEANUP" EXIT TERM INT QUIT } # create a scratch dir for any temporary files needed if SCRATCH_DIR=$(mktemp -d ~/.ssh/ssh-copy-id.XXXXXXXXXX) && [ "$SCRATCH_DIR" ] && [ -d "$SCRATCH_DIR" ] then chmod 0700 "$SCRATCH_DIR" SCRATCH_CLEANUP="rm -rf \"$SCRATCH_DIR\"" #shellcheck disable=SC2064 trap "$SCRATCH_CLEANUP" EXIT TERM INT QUIT else printf '%s: ERROR: failed to create required temporary directory under ~/.ssh\n' "$0" >&2 exit 1 fi REMOTE_VERSION=$($SSH -v -o PreferredAuthentications=',' -o ControlPath=none "$@" 2>&1 | sed -ne 's/.*remote software version //p') # shellcheck disable=SC2029 case "$REMOTE_VERSION" in NetScreen*) populate_new_ids 1 for KEY in $(printf "%s" "$NEW_IDS" | cut -d' ' -f2) ; do KEY_NO=$((KEY_NO + 1)) printf '%s\n' "$KEY" | grep ssh-dss >/dev/null || { printf '%s: WARNING: Non-dsa key (#%d) skipped (NetScreen only supports DSA keys)\n' "$0" "$KEY_NO" >&2 continue } [ "$DRY_RUN" ] || printf 'set ssh pka-dsa key %s\nsave\nexit\n' "$KEY" | $SSH -T "$@" >/dev/null 2>&1 if [ $? = 255 ] ; then printf '%s: ERROR: installation of key #%d failed (please report a bug describing what caused this, so that we can make this message useful)\n' "$0" "$KEY_NO" >&2 else ADDED=$((ADDED + 1)) fi done if [ -z "$ADDED" ] ; then exit 1 fi ;; dropbear*) populate_new_ids 0 [ "$DRY_RUN" ] || printf '%s\n' "$NEW_IDS" | \ $SSH "$@" "$(installkeys_sh /etc/dropbear/authorized_keys)" \ || exit 1 ADDED=$(printf '%s\n' "$NEW_IDS" | wc -l) ;; *) # Assuming that the remote host treats ~/.ssh/authorized_keys as one might expect populate_new_ids 0 if ! [ "$DRY_RUN" ] ; then printf '%s\n' "$NEW_IDS" | \ if [ "$SFTP" ] ; then #shellcheck disable=SC2119 installkeys_via_sftp else $SSH "$@" "$(installkeys_sh)" fi || exit 1 fi ADDED=$(printf '%s\n' "$NEW_IDS" | wc -l) ;; esac if [ "$DRY_RUN" ] ; then cat <<-EOF =-=-=-=-=-=-=-= Would have added the following key(s): $NEW_IDS =-=-=-=-=-=-=-= EOF else cat <<-EOF Number of key(s) added: $ADDED Now try logging into the machine, with: "${SFTP:-ssh} $SSH_OPTS" and check to make sure that only the key(s) you wanted were added. EOF fi # =-=-=-=